Github messages for voidlinux
 help / color / mirror / Atom feed
From: Chocimier <Chocimier@users.noreply.github.com>
To: ml@inbox.vuxu.org
Subject: Re: [PR PATCH] [Updated] [RFC] 11-pkglint-elf-in-usrshare: allow explicit setting of exceptions
Date: Tue, 25 Aug 2020 21:14:35 +0200	[thread overview]
Message-ID: <20200825191435.PjwqRW5k9n-coxtKkLDhksaFOo2mqalbgaHMq-hW_m4@z> (raw)
In-Reply-To: <gh-mailinglist-notifications-41a7ca26-5023-4802-975b-f1789d68868e-void-packages-23601@inbox.vuxu.org>

[-- Attachment #1: Type: text/plain, Size: 538 bytes --]

There is an updated pull request by Chocimier against master on the void-packages repository

https://github.com/Hoshpak/void-packages allow_usr_share_exceptions
https://github.com/void-linux/void-packages/pull/23601

[RFC] 11-pkglint-elf-in-usrshare: allow explicit setting of exceptions
This will allow to explicitely ignore files in the hook where it otherwise would create false positives like in the case of qemu.

@void-linux/pkg-committers

A patch file from https://github.com/void-linux/void-packages/pull/23601.patch is attached

[-- Warning: decoded text below may be mangled, UTF-8 assumed --]
[-- Attachment #2: github-pr-allow_usr_share_exceptions-23601.patch --]
[-- Type: text/x-diff, Size: 5319 bytes --]

From d5ca1af76778b15590be6d56085e5531749fd5c6 Mon Sep 17 00:00:00 2001
From: Helmut Pozimski <helmut@pozimski.eu>
Date: Thu, 16 Jul 2020 19:44:01 +0200
Subject: [PATCH 1/2] 11-pkglint-elf-in-usrshare: allow explicit setting of
 exceptions
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Co-authored-by: Piotr Wójcik <chocimier@tlen.pl>
---
 Manual.md                                     | 10 ++++++--
 .../11-pkglint-elf-in-usrshare.sh             | 23 ++++++++++++++++---
 2 files changed, 28 insertions(+), 5 deletions(-)

diff --git a/Manual.md b/Manual.md
index 8a8954e88d7..4691cbb136b 100644
--- a/Manual.md
+++ b/Manual.md
@@ -141,7 +141,7 @@ to be accepted. New fonts are welcome if they provide value beyond
 aesthetics (e.g. they contain glyphs for a script missing in already
 packaged fonts).
 
-Browser forks, including those based on Chromium and Firefox, are generally not 
+Browser forks, including those based on Chromium and Firefox, are generally not
 accepted. Such forks require heavy patching, maintenance and hours of build time.
 
 <a id="buildphase"></a>
@@ -623,6 +623,12 @@ the `$DESTDIR` which will not be scanned for runtime dependencies. This may be u
 skip files which are not meant to be run or loaded on the host but are to be sent to some
 target device or emulation.
 
+- `ignore_elf_files` White space separated list of machine code files
+in /usr/share directory specified by absolute path, which are expected and allowed.
+
+- `ignore_elf_dirs` White space separated list of directories in /usr/share directory
+specified by absolute path, which are expected and allowed to contain machine code files.
+
 - `nocross` If set, cross compilation won't be allowed and will exit immediately.
 This should be set to a string describing why it fails, or a link to a travis
 buildlog demonstrating the failure.
@@ -950,7 +956,7 @@ Environment variables for a specific `build_style` can be declared in a filename
 matching the `build_style` name, Example:
 
     `common/environment/build-style/gnu-configure.sh`
-    
+
 - `texmf` For texmf zip/tarballs that need to go into /usr/share/texmf-dist. Includes
 duplicates handling.
 
diff --git a/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh b/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh
index ff4f7789e86..bd0a4f25725 100644
--- a/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh
+++ b/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh
@@ -2,26 +2,43 @@
 #
 # This hook executes the following tasks:
 #   - Looks on all packages for binary files being installed to /usr/share
+#   - Allows exceptions listed in $ignore_elf_files and $ignore_elf_dirs
 
 hook() {
-    local matches mime file
+    local matches mime file f prune_expr dir
 
     if [ ! -d ${PKGDESTDIR}/usr/share ]; then
         return 0
     fi
 
+    if [ "${ignore_elf_dirs}" ]; then
+        for dir in ${ignore_elf_dirs}; do
+            if ! [ "${prune_expr}" ]; then
+                prune_expr="( -path ${PKGDESTDIR}${dir}"
+            else
+                prune_expr+=" -o -path ${PKGDESTDIR}${dir}"
+            fi
+        done
+        prune_expr+=" ) -prune -o "
+    fi
+
     # Find all binaries in /usr/share and add them to the pool
     while read -r f; do
         mime="${f##*:}"
         mime="${mime// /}"
         file="${f%:*}"
+        file="${file#${PKGDESTDIR}}"
         case "${mime}" in
             # Note application/x-executable is missing which is present in most Electron apps
             application/x-sharedlib*|application/x-pie-executable*)
-                matches+=" ${file#$PKGDESTDIR}" ;;
+                if [[ ${ignore_elf_files} != *"${file}"* ]]; then
+                    matches+=" ${file}"
+                fi
+                ;;
         esac
-    done < <(find $PKGDESTDIR/usr/share -type f | file --mime-type --files-from -)
+    done < <(find $PKGDESTDIR/usr/share $prune_expr -type f | file --mime-type --files-from -)
 
+    # Check passed if no packages in pool
     if [ -z "$matches" ]; then
         return 0
     fi

From 839a7f9efec1777fbe2be128bf2f69d3da6bd5f2 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Piotr=20W=C3=B3jcik?= <chocimier@tlen.pl>
Date: Tue, 4 Aug 2020 22:28:14 +0200
Subject: [PATCH 2/2] 11-pkglint-elf-in-usrshare: disallow x-executable

Can be allowed per-package now
---
 common/hooks/post-install/11-pkglint-elf-in-usrshare.sh | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh b/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh
index bd0a4f25725..a665f3ed94d 100644
--- a/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh
+++ b/common/hooks/post-install/11-pkglint-elf-in-usrshare.sh
@@ -29,8 +29,9 @@ hook() {
         file="${f%:*}"
         file="${file#${PKGDESTDIR}}"
         case "${mime}" in
-            # Note application/x-executable is missing which is present in most Electron apps
-            application/x-sharedlib*|application/x-pie-executable*)
+            application/x-sharedlib*|\
+             application/x-pie-executable*|\
+             application/x-executable*)
                 if [[ ${ignore_elf_files} != *"${file}"* ]]; then
                     matches+=" ${file}"
                 fi

  parent reply	other threads:[~2020-08-25 19:14 UTC|newest]

Thread overview: 26+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-07-16 17:46 [PR PATCH] " Hoshpak
2020-07-16 18:29 ` pullmoll
2020-07-16 18:30 ` [PR REVIEW] " ahesford
2020-07-16 19:09 ` [PR PATCH] [Updated] " Hoshpak
2020-07-16 19:18 ` Hoshpak
2020-07-16 19:20 ` Hoshpak
2020-07-16 23:28 ` [PR REVIEW] " Johnnynator
2020-07-16 23:29 ` Johnnynator
2020-07-17 10:56 ` Piraty
2020-07-20 19:27 ` [PR PATCH] [Updated] " Hoshpak
2020-07-20 19:29 ` Hoshpak
2020-07-20 19:31 ` Hoshpak
2020-07-20 19:53 ` ahesford
2020-07-22 22:07 ` Chocimier
2020-07-23 16:34 ` Hoshpak
2020-07-29 20:54 ` Chocimier
2020-07-30 15:07 ` Hoshpak
2020-08-05 20:00 ` [PR PATCH] [Updated] " Chocimier
2020-08-05 20:00 ` Chocimier
2020-08-05 20:07 ` Chocimier
2020-08-05 20:11 ` [PR PATCH] [Updated] " Chocimier
2020-08-20 17:50 ` Chocimier
2020-08-20 17:50 ` Chocimier
2020-08-20 17:53 ` Chocimier
2020-08-25 19:14 ` Chocimier [this message]
2020-08-25 19:19 ` [PR PATCH] [Merged]: " Chocimier

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200825191435.PjwqRW5k9n-coxtKkLDhksaFOo2mqalbgaHMq-hW_m4@z \
    --to=chocimier@users.noreply.github.com \
    --cc=ml@inbox.vuxu.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).